﻿using AutoMapper;
using Lab3.Database.Repository.Interfaces;
using Lab3.Models;

namespace Lab3.Forms
{
    public partial class MainForm : Form
    {
        private readonly IStudentRepository _studentRepository;
        private readonly IMapper _mapper;

        public MainForm(
            IStudentRepository repository,
            IMapper mapper)
        {
            _studentRepository = repository;    
            _mapper = mapper;
            InitializeComponent();
        }

        private async void MainForm_LoadAsync(object sender, EventArgs e)
        {
            var students = _mapper.Map<List<StudentViewModel>>(await _studentRepository.GetAsync());
            StudentsListBox.FillListBox(students);
        }
    }
}
